# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []

def install():

    def versmathgrap32(key):
        return key['name'].replace('MathGraph32 JS','').replace(' 64 bits','')


    for oldmathgraph32 in installed_softwares('MathGraph32 Java'):
        run(uninstall_cmd(oldmathgraph32['key']))

    print('installing mathgraph32')
    versionsoft = control['version'].split('-',1)[0]
    for soft in installed_softwares('{31BC28F5-98A9-4C4F-828E-22F937C4E349}_is1'):
        if '32 bit' in soft['name']:
            run(uninstall_cmd('{31BC28F5-98A9-4C4F-828E-22F937C4E349}_is1'))
    install_exe_if_needed("setupMathGraph32JS-64bits.exe",'/VERYSILENT /SUPPRESSMSGBOXES /NORESTART',key='{31BC28F5-98A9-4C4F-828E-22F937C4E349}_is1',min_version=versionsoft,get_version=versmathgrap32)
    remove_desktop_shortcut('MathGraph32JS')




def update_package():
    proxies = {}
    if isfile(makepath(user_local_appdata(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxies = {'http':proxywapt,'https':proxywapt}

    htmlsource = wgets('https://www.mathgraph32.org/',proxies=proxies)
    version = ensure_unicode(wgets("https://www.mathgraph32.org/",proxies=proxies)).split('MathGraph32JS V ')[1].split('<br')[0]
    print("Last version is " + version)

    for exe in glob.glob('*.exe'):
        if Version(get_file_properties(exe)['ProductVersion']) < Version(version):
            remove_file(exe)

    url = 'https://www.mathgraph32.org/IMG/zip/setupmathgraph32js-64bits.zip'
    if not glob.glob('*.exe'):
        wget(url,'setupmathgraph32js-64bits.zip',proxies=proxies)
        unzip('setupmathgraph32js-64bits.zip')
        remove_file('setupmathgraph32js-64bits.zip')
        for exefinal in glob.glob(r'*\*.exe'):
            filecopyto(exefinal,exefinal.split('\\')[1])
            remove_tree(exefinal.split('\\')[0])

    else:
        print('Version %s already in the folder' %version)

    control.version = get_file_properties(glob.glob('*.exe')[0])['ProductVersion'].strip() + '-0'
    control.save_control_to_wapt()


